import React, { useState } from "react";
import logo from "./logo.svg";
import "./App.css";

interface GreeterProps {
  name: string;
  setName: (name: string) => void;
}

const Greeter: React.FC<GreeterProps> = ({ name, setName }) => {
  return (
    <div>
      <div>{name.length ? <>Hello {name}</> : <>What is your name? </>}</div>
      <input
        autoFocus
        type="text"
        value={name}
        onChange={(e) => setName(e.target.value)}
      />
    </div>
  );
};

function App() {
  const [count, setCount] = useState(0);
  const [name, setName] = useState("");
  return (
    <div className="App">
      <header className="App-header">
        <img
          src={logo}
          className="App-logo"
          alt="logo"
          style={{
            animationDuration: `${20 / (name.length || 1)}s`
          }}
        />
        <p>Hello Vite + React!</p>
        <p>
          <button type="button" onClick={() => setCount((count) => count + 1)}>
            count is: {count}
          </button>
        </p>
        <Greeter name={name} setName={setName} />
      </header>
    </div>
  );
}

export default App;
